Index: lib/eml.jar
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: lib/web.xml
===================================================================
--- lib/web.xml	(revision 1531)
+++ lib/web.xml	(revision 1532)
@@ -1,120 +1,51 @@
-<!DOCTYPE web-app 
-    PUBLIC "-//Sun Microsystems, Inc.//DTD Web Application 2.2//EN" 
+<!DOCTYPE web-app
+    PUBLIC "-//Sun Microsystems, Inc.//DTD Web Application 2.2//EN"
         "http://java.sun.com/j2ee/dtds/web-app_2_2.dtd">
 
 <web-app>
+    <display-name>monarch</display-name>
 
-
-    <!-- General description of your web application -->
-
-    <display-name>Metadata Catalog Demo</display-name>
-    <description>
-      This version is a development release only.
-    </description>
-
-
-    <!-- Context initialization parameters that define shared
-         String constants used within your application, which
-         can be customized by the system administrator who is
-         installing your application.  The values actually
-         assigned to these parameters can be retrieved in a
-         servlet or JSP page by calling:
-
-             String value =
-               getServletContext().getInitParameter("name");
-
-         where "name" matches the <param-name> element of
-         one of these initialization parameters.
-
-         You can define any number of context initialization
-         parameters, including zero.
-    -->
-
     <context-param>
       <param-name>jones</param-name>
       <param-value>jones@nceas.ucsb.edu</param-value>
       <description>
-        The EMAIL address of the administrator to whom questions
-        and comments about this application should be addressed.
       </description>
     </context-param>
 
-
-    <!-- Servlet definitions for the servlets that make up
-         your web application, including initialization
-         parameters.  With Tomcat, you can also send requests
-         to servlets not listed here with a request like this:
-
-           http://localhost:8080/{context-path}/servlet/{classname}
-
-         but this usage is not guaranteed to be portable.  It also
-         makes relative references to images and other resources
-         required by your servlet more complicated, so defining
-         all of your servlets (and defining a mapping to them with
-         a <servlet-mapping> element) is recommended.
-
-         Servlet initialization parameters can be retrieved in a
-         servlet or JSP page by calling:
-
-             String value =
-               getServletConfig().getInitParameter("name");
-
-         where "name" matches the <param-name> element of
-         one of these initialization parameters.
-
-         You can define any number of servlets, including zero.
-    -->
-
     <servlet>
       <servlet-name>metacat</servlet-name>
-      <description>
-        The main controlling servlet for the metacat application.
-      </description>
       <servlet-class>edu.ucsb.nceas.metacat.MetaCatServlet</servlet-class>
-      <!-- Load this servlet at server startup time -->
-      <load-on-startup>5</load-on-startup>
+      <init-param>
+        <param-name>debug</param-name>
+        <param-value>1</param-value>
+      </init-param>
+      <init-param>
+        <param-name>listings</param-name>
+        <param-value>true</param-value>
+      </init-param>
+      <load-on-startup>1</load-on-startup>
     </servlet>
     
-    <servlet>
+     <servlet>
       <servlet-name>replication</servlet-name>
-       <description>
-         The replication control servlet for metacat
-       </description>
       <servlet-class>edu.ucsb.nceas.metacat.MetacatReplication</servlet-class>
-      <load-on-startup>5</load-on-startup>
+      <init-param>
+        <param-name>debug</param-name>
+        <param-value>1</param-value>
+      </init-param>
+      <init-param>
+        <param-name>listings</param-name>
+        <param-value>true</param-value>
+      </init-param>
+      <load-on-startup>1</load-on-startup>
     </servlet>
 
-
-    <!-- Define mappings that are used by the servlet container to
-         translate a particular request URI (context-relative) to a
-         particular servlet.  The examples below correspond to the
-         servlet descriptions above.  Thus, a request URI like:
-
-           http://localhost:8080/{contextpath}/graph
-
-         will be mapped to the "graph" servlet, while a request like:
-
-           http://localhost:8080/{contextpath}/saveCustomer.do
-
-         will be mapped to the "controller" servlet.
-
-         You may define any number of servlet mappings, including zero.
-         It is also legal to define more than one mapping for the same
-         servlet, if you wish to.
-    -->
-
     <servlet-mapping>
-      <servlet-name>metacat</servlet-name>
-      <url-pattern>/metacat*</url-pattern>
+        <servlet-name>invoker</servlet-name>
+        <url-pattern>/servlet/*</url-pattern>
     </servlet-mapping>
-    
-    <!-- Define the default session timeout for your application,
-         in minutes.  From a servlet or JSP page, you can modify
-         the timeout for a particular session dynamically by using
-         HttpSession.getMaxInactiveInterval(). -->
 
     <session-config>
-      <session-timeout>30</session-timeout>    <!-- 30 minutes -->
+      <session-timeout>30</session-timeout>
     </session-config>
-
 </web-app>